/*
 *
 * AttributeFlight
 *
 * The flight attribute
 *
 *
*/

package jesse.keeblarcraft.AttributeMgr.AttributeNodes;

import java.util.HashMap;
import java.util.List;

import jesse.keeblarcraft.Keeblarcraft;
import net.fabricmc.fabric.api.event.player.AttackBlockCallback;
import net.minecraft.block.BlockState;
import net.minecraft.util.ActionResult;

public class AttributeFlight extends AbstractNode {

    public AttributeFlight() {

    }

    @Override
    public String GetNodeTitle() {
        return "attribute_low_health_flight";
    }

    @Override
    public String GetNodeDescription() {
        return "Gives player flight with low health";
    }

    @Override
    public HashMap<String, List<String>> GetDetails() {
        HashMap<String, List<String>> ret = new HashMap<String, List<String>>();

        // Filling out description item stuff here
        ret.put("Flight", List.of   (
                                    "Gives a player natural flight if they have less than or equal to two hearts remaining"
                                    ));

        return ret;
    }

    @Override
    public void RegisterCallbacks() {
        // Register events here
        AttackBlockCallback.EVENT.register((player, world, hand, pos, direction) -> {
            BlockState state = world.getBlockState(pos);

            Keeblarcraft.LOGGER.info("Callback for AttackBlockCallback called");
            // Manual spectator check is necessary because AttackBlockCallbacks fire before the spectator check
            if (!player.isSpectator() && player.getMainHandStack().isEmpty() && state.isToolRequired()) {
                player.damage(world.getDamageSources().generic(), 1.0F);
            }

            return ActionResult.PASS;
        });
    }
}
